// ----------------------------------------------------------
// This Source Code Form is subject to the terms of the
// Mozilla Public License, v.2.0. If a copy of the MPL
// was not distributed with this file, You can obtain one
// at http://mozilla.org/MPL/2.0/.
// ----------------------------------------------------------
// Codebase: https://github.com/ArKuznetsov/cpdb/
// ----------------------------------------------------------

// Процедура - устанавливает описание команды
//
// Параметры:
//  Команда    - КомандаПриложения     - объект описание команды
//
Процедура ОписаниеКоманды(Команда) Экспорт

	Команда.ДобавитьКоманду("put p",
	                        "поместить файл на сервер SFTP",
	                        Новый КомандаПоместитьФайлНаSFTP());

	Команда.ДобавитьКоманду("get g",
	                        "скачать файл с сервера SFTP",
	                        Новый КомандаПолучитьФайлСSFTP());

	Команда.Опция("s srvr server", "", "адрес сервера SFTP в виде ""<адрес>:<порт>""")
	       .ТСтрока()
	       .Обязательный()
	       .ВОкружении("CPDB_SFTP_SRVR");

	Команда.Опция("u user", "", "Пользователь сервера SFTP")
	       .ТСтрока()
	       .Обязательный()
	       .ВОкружении("CPDB_SFTP_USER");

	Команда.Опция("p pwd", "", "Пароль пользователя сервера SFTP,
	                           | если указан параметр ""--key-file"",
	                           | то используется как пароль для доступа к закрытому ключу")
	       .ТСтрока()
	       .ВОкружении("CPDB_SFTP_PWD");

	Команда.Опция("k key-file", "", "Путь к файлу закрытого ключа сервера SFTP,
	                                | если указано, то параметр ""--pwd""
	                                | интерпретируется как пароль к закрытому ключу")
	       .ТСтрока()
	       .ВОкружении("CPDB_SFTP_KEY_FILE");

КонецПроцедуры // ОписаниеКоманды()
