// ----------------------------------------------------------
// This Source Code Form is subject to the terms of the
// Mozilla Public License, v.2.0. If a copy of the MPL
// was not distributed with this file, You can obtain one
// at http://mozilla.org/MPL/2.0/.
// ----------------------------------------------------------
// Codebase: https://github.com/ArKuznetsov/cpdb/
// ----------------------------------------------------------

// Процедура - устанавливает описание команды
//
// Параметры:
//  Команда    - КомандаПриложения     - объект описание команды
//
Процедура ОписаниеКоманды(Команда) Экспорт

	Команда.ДобавитьКоманду("create-srv-ib create createib cs",
	                        "создать информационную базу 1С на сервере",
	                        Новый КомандаСоздатьСервернуюИБ());

	Команда.ДобавитьКоманду("create-file-ib cf",
	                        "создать файловую информационную базу 1С",
	                        Новый КомандаСоздатьФайловуюИБ());

	Команда.ДобавитьКоманду("dump dumpib d",
	                        "выгрузить информационную базу 1С в DT-файл",
	                        Новый КомандаВыгрузитьИБВФайл());

	Команда.ДобавитьКоманду("restore restoreib r",
	                        "загрузить информационную базу 1С из DT-файла",
	                        Новый КомандаЗагрузитьИБИзФайла());

	Команда.ДобавитьКоманду("clearcache cc",
	                        "очистить локальный кэш базы 1С",
	                        Новый КомандаОчиститьЛокальныйКэшИБ());

	Команда.ДобавитьКоманду("uconstorage us",
	                        "отключить информационную базу 1С от хранилища",
	                        Новый КомандаОтключитьОтХранилища());

	Команда.ДобавитьКоманду("constorage cs",
	                        "подключить информационную базу 1С к хранилищу",
	                        Новый КомандаПодключитьКХранилищу());

	Команда.Опция("v v8version", "8.3", "маска версии платформы 1С")
	       .ТСтрока()
	       .ВОкружении("CPDB_IB_V8VERSION");

КонецПроцедуры // ОписаниеКоманды()
